// The auto_array class is good for holding arrays in classes, where you want the destructor
// to automatically destroy the array. They are much more restricted in strength and use than
// the auto_ptr type.
#ifndef AUTO_ARRAY_H
#define AUTO_ARRAY_H

template <class T>
   class auto_array
{
   auto_array( const auto_array & rhs ); // No copy constructor
   auto_array & operator= ( const auto_array & rhs ); // And definetly no =

   T *data;
public:
   explicit auto_array( T * pointer ) : data( pointer )
   {
   }

   ~auto_array() // Not virtual - the size of this class is exactly the size of the pointer
   {
      delete [] data;
   }

   // A few data manipulation functions
   T & operator[] ( int index )
   {
      return data[ index ];
   }

   const T & operator[] ( int index ) const
   {
      return data[ index ];
   }

   operator const T * () const
   {
      return data;
   }

   operator T * ()
   {
      return data;
   }
};

#endif // AUTO_ARRAY_H
