// xeyes.cpp : Defines the entry point for the application.
//

// This file is part of the Xeyes for windows program (c) copyright 1998 Shachar Shemesh
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation version 2 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//                                             
#include "stdafx.h"
#include "resource.h"
#include "ui.h"

CSTR XEYES_WND_CLASS_NAME="Xeyes window class";

LRESULT CALLBACK WndProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	WNDCLASS wndclass;

	wndclass.cbClsExtra=0;
	wndclass.cbWndExtra=0;
	wndclass.hbrBackground=CreateSolidBrush(WHITE);
	wndclass.hCursor=LoadCursor(NULL, IDC_ARROW );
	wndclass.hIcon=LoadIcon( hInstance, MAKEINTRESOURCE(IDI_XEYES) );
	wndclass.lpfnWndProc=WndProc;
	wndclass.lpszClassName=XEYES_WND_CLASS_NAME;
	wndclass.lpszMenuName=NULL;
   wndclass.hInstance=hInstance;
	wndclass.style=CS_HREDRAW|CS_VREDRAW;

	ATOM aWndClass=RegisterClass(&wndclass);

	CRegKey key=HKCU.Create(XEYES_REGISTRY_KEY);

	HWND hwnd=CreateWindow( XEYES_WND_CLASS_NAME, "xeyes", WS_OVERLAPPEDWINDOW,
		key.QueryValue( "Left", CW_USEDEFAULT ), key.QueryValue( "Top", CW_USEDEFAULT ),
		key.QueryValue( "Width", CW_USEDEFAULT ),	key.QueryValue( "Height", CW_USEDEFAULT ),
		NULL, NULL, hInstance, NULL );

   LRESULT res=GetLastError();

   ShowWindow( hwnd, nCmdShow );

   MSG msg;

   while( GetMessage( &msg, NULL, 0, 0 ) )
   {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
   }

   UnregisterClass( reinterpret_cast<char *>(MAKELONG( aWndClass, 0 )), hInstance );

	return 0;
}

